%define		module vloopback

Name:    	dkms-%{module}
Version: 	1.2
Release: 	%mkrel 1

Summary: 	Vloopback is a video4linux driver providing video pipes.
License: 	GPLv2
Group:   	System/Kernel and hardware
Source0:   	%{module}-%{version}.tar.gz
Source1:  	vloopback-1.3.diff
Source2:  	vloopback-1.4.diff
URL:		http://www.lavrsen.dk/twiki/bin/view/Motion/VideoFourLinuxLoopbackDevice
BuildRoot: 	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildArch: 	noarch
Requires(post): dkms
Requires(reun): dkms

%description
This is a modfied version of the vloopback driver from
Jeroen Vreeken et al.
Modifications consist in:
1) You can choose minor numbers of input and output devices
2) Write is made block when nobody is reading the other
end of the pipe.

-Olivier Debon	(olivier@debon.net)

------------------------------------------------------
With the driver you can use the output of a user program to feed a program that
would normally communicate with a video4linux device.To achieve this a video pipe 
consists out of two video4linux devices:one for the generating program to write its 
data to and one for a normal video4linux program to read from. At the moment there 
are only few programs that can feed the input of the pipe: invert and resize, 
the example programs with the driver and motion, my motion detection program.

%prep
%setup -q -n %{module}-%{version}
patch vloopback.c %{SOURCE1}
patch vloopback.c %{SOURCE2}

%install
rm -rf %{buildroot}
mkdir -p $RPM_BUILD_ROOT/usr/src/%{module}-%{version}-%{release}/
cp -R * $RPM_BUILD_ROOT/usr/src/%{module}-%{version}-%{release}/

cat > $RPM_BUILD_ROOT/usr/src/%{module}-%{version}-%{release}/dkms.conf <<EOF
PACKAGE_NAME="%{module}"
PACKAGE_VERSION="%{version}-%{release}"

DEST_MODULE_LOCATION[0]="/kernel/drivers/misc"
BUILT_MODULE_NAME[0]="%{module}"
MAKE[0]="cd \${dkms_tree}/\${PACKAGE_NAME}/\${PACKAGE_VERSION}/build ; make"
CLEAN="cd \${dkms_tree}/\${PACKAGE_NAME}/\${PACKAGE_VERSION}/build ; make clean"
AUTOINSTALL="yes"
EOF

# Istalling a kernel-module preload
mkdir -p $RPM_BUILD_ROOT/etc/modprobe.preload.d/
cat > $RPM_BUILD_ROOT/etc/modprobe.preload.d/%{module} <<EOF
%{module}
EOF

%clean
rm -rf %{buildroot}

%files
%defattr(0644,root,root,0755)
/etc/modprobe.preload.d/%{module}
/usr/src/%{module}-%{version}-%{release}/*

%post
/usr/sbin/dkms add -m %{module} -v %{version}-%{release} --rpm_safe_upgrade
/usr/sbin/dkms build -m %{module} -v %{version}-%{release} --rpm_safe_upgrade
/usr/sbin/dkms install -m %{module} -v %{version}-%{release} --rpm_safe_upgrade
/sbin/modprobe %{module}
exit 0

%preun
/usr/sbin/dkms remove -m %{module} -v %{version}-%{release} --rpm_safe_upgrade --all
/sbin/rmmod %{module}
exit 0

%changelog
* Thu Jun 18 2009 Dal Magro Maurizio <mauriziodm@mandrivaclub.be>
- New version + 2 patches for kernel >= 2.6.29.x

* Wed Apr 29 2009 Dal Magro Maurizio <mauriziodm@mandrivaclub.be>
- Build for Mandriva 2009.1

* Tue Apr 14 2009 Maurizio Dal Magro <mauriziodm@mandrivaclub.be>
- First build
